/* FILE NAME: intbind.c */
/* Interpret binding information and return the protocol sequence. */
#include <stdio.h>
#include <rpc.h>
#include "..\status.h"

void do_interpret_binding(binding, protocol_seq)
rpc_binding_handle_t binding;    /* binding handle to interpret             */
char                 *protocol_seq;    /* protocol sequence to obtain       */
{
   unsigned long   status;             /* error status                      */
   unsigned char   *string_binding;    /* string of binding information     */
   unsigned char   *protseq;           /* binding component of interest     */

   status =
   RpcBindingToStringBinding(    /* convert binding information to string   */
      binding,                             /* the binding handle to convert */
      &string_binding                      /* the string of binding data    */
   );
   CHECK_STATUS(status, "Can't get string binding:", RESUME);

   status =
   RpcStringBindingParse(             /* get components of string binding   */
      string_binding,           /* the string of binding data               */
      NULL,                     /* an object UUID string is not obtained    */
      &protseq,                 /* a protocol sequence string IS obtained   */
      NULL,                     /* a network address string is not obtained */
      NULL,                     /* an endpoint string is not obtained       */
      NULL                      /* a network options string is not obtained */
   );
   CHECK_STATUS(status, "Can't parse string binding:", RESUME);

   strcpy(protocol_seq, (char *)protseq);

   /* free all strings allocated by other runtime routines                  */
   status = RpcStringFree(&string_binding);
   status = RpcStringFree(&protseq       );
   return;
}
